#define _CRT_SECURE_NO_WARNINGS
#include <cstring>
#include <iostream>

using namespace std;

#pragma pack(push,2)
struct test1{
	char a : 2;
	long b : 3;
	char c : 2;
	short d : 1;
	long long int e : 3;
};
struct test2{
	char a : 2;
	long b : 3;
	char c : 2;
	short d : 1;
	//long long int e:3;
};
#pragma pack(pop)

struct Bil {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned int arsmod : 7;
	unsigned int skatt_betald : 1;
	unsigned int besiktigad : 1;
	unsigned int avstalld : 1;
};

struct Bil2 {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned short arsmod : 7;
	unsigned short skatt_betald : 1;
	unsigned short besiktigad : 1;
	unsigned short avstalld : 1;
};

struct Bil3 {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned char arsmod : 7;
	unsigned char skatt_betald : 1;
	unsigned char besiktigad : 1;
	unsigned char avstalld : 1;
};

struct Bil4 {// post i ett bilregister
public:
	char reg_nr[7];
	unsigned char arsmod : 7;
	unsigned char skatt_betald : 1;
	unsigned char besiktigad : 1;
	unsigned char avstalld : 1;
};

struct Bil5 {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned char reg_nr_fill;
	unsigned char arsmod : 7;
	unsigned char skatt_betald : 1;
	unsigned char besiktigad : 1;
	unsigned char avstalld : 1;
};

struct Bil6 {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned char reg_nr_fill;
	unsigned short arsmod : 7;
	unsigned short skatt_betald : 1;
	unsigned short besiktigad : 1;
	unsigned short avstalld : 1;
};

#pragma pack(push,1)
struct Bil7 {// post i ett bilregister
public:
	char reg_nr[6];
	unsigned char reg_nr_fill;
	unsigned short arsmod : 7;
	unsigned short skatt_betald : 1;
	unsigned short besiktigad : 1;
	unsigned short avstalld : 1;
};
#pragma pack(pop)


int main() {

//	cout << "test1:" << sizeof(test1) << " test2:" << sizeof(test2) << endl;

	cout << "sizeof(Bil):  " << sizeof(Bil) << endl;
	cout << "sizeof(Bil2): " << sizeof(Bil2) << endl;
	cout << "sizeof(Bil3): " << sizeof(Bil3) << endl;
	cout << "sizeof(Bil4): " << sizeof(Bil4) << endl;
	cout << "sizeof(Bil5): " << sizeof(Bil5) << endl;
	cout << "sizeof(Bil6): " << sizeof(Bil6) << endl;
	cout << "sizeof(Bil7): " << sizeof(Bil7) << endl;

	Bil2 b;
	strncpy(b.reg_nr, "ABC123", 6);
	b.arsmod = 97;
	b.skatt_betald = true;
	b.besiktigad = true;
	b.avstalld = false;
	cout << "rsmodell: " << b.arsmod << endl;
	if (b.skatt_betald && b.besiktigad)
		cout << "OK" << endl;

	unsigned long long bb = 0;   // samma storlek som Bil2
	memcpy(&bb, &b, sizeof(bb));
	cout << hex << bb << endl;

	cin >> ws;
}